const axios = require('axios')

class FosTabController {
    constructor(){
        this.promoProducts = []
    };      

    getFiliais( req, res){
        let filterParams = { 'NRORG' : 1 }
        req.app.model.FiliaisModel.getFiliais(req.app, filterParams).then( filiais => {            
            //createStructure = [...handleStructure(structure)];
            res.send( filiais.rows )
        })
    }


    get(req, res){
        let owner = 'TEKNISA';
        let structure = [];

        let myPromises = [];
        let creates = [];
        let createStructure = [];
        let createContraints = [];
        let createContraintsFromIndexes = []
        let filterParams = {
            'OWNER' : owner
        }        

        function handleStructure(structure){
            // TODO foreach em todos os items aninhados
            let current_table = '';
            let start = true;
            let ddl = '';
            let cpIdx = 0;
            let createStructure = []
    
            structure.rows.forEach( field => {
    
                if( current_table != field[0]){
                    current_table = field[0]
    
                    // Se não for o inicio, fecha a instrução de criação
                    ddl += !start ? ') ' : '' 
    
                    createStructure.push( ddl )
    
                    ddl = 'CREATE TABLE '+current_table+'('                   
                    start = false;
                    cpIdx = 0;
                }
    
                //Separa por virgula depois do primeiro campo da tabela
                if(cpIdx != 0){
                    ddl += ','
                }
                ddl += field[1]+' '+field[2]+' '+field[3];
                
                if( !!field[4] ) {
                    if(  field[4].substring(0, 7).toUpperCase().trim() == 'SYSDATE' ){
                        ddl += ' default GETDATE()'
                    } else if(  field[4].substring(0, 12).toUpperCase().trim() == 'CURRENT_DATE' ){
                        ddl += ' default GETDATE()'
                    } else if (field[4].substring(0, 32) == `SYS_CONTEXT('nrorg_ctx','nrorg')`){
                        ddl += ` default '${field[5]}'` // Default NRORG
                    } else {
                        ddl += ' default '+field[4]
                    }
                }
                cpIdx++                
            });
    
            return createStructure;
        };

        function handleConstraintsFromIndexes(constraints){
            // TODO foreach em todos os items aninhados
            let current_table = '';
            let start = true;
            let ddl_pk = '';
            let ddl_fk = '';
            let cpIdx_pk = 0;
            let cpIdx_fk = 0;
            let createConstraints = []

            
    
            constraints.rows.forEach( field => {
    
                if( current_table != field[0]){
                    current_table = field[0]
    
                    // Se não for o inicio, fecha a instrução de criação
                    ddl_pk += !start ? ') ' : '' 
                    
                    createConstraints.push( ddl_pk )
                    ddl_pk = `IF EXISTS (SELECT 1 FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_TYPE='BASE TABLE' AND TABLE_NAME='${current_table}') `
                    ddl_pk += 'ALTER TABLE '+current_table+' ADD CONSTRAINT PK_'+current_table+' PRIMARY KEY (';                
                    
                    start = false;

                    cpIdx_pk = 0;
                    cpIdx_fk = 0;
                }
    
                //Separa por virgula depois do primeiro campo
                if(cpIdx_pk != 0){
                    ddl_pk += ','
                }
                ddl_pk += field[1]
                cpIdx_pk++                
            }); 
    
            return createConstraints;
        };
    
        function handleConstraints(constraints){
            // TODO foreach em todos os items aninhados
            let current_table = '';
            let start = true;
            let ddl_pk = '';
            let ddl_fk = '';
            let cpIdx_pk = 0;
            let cpIdx_fk = 0;
            let createConstraints = []

            
    
            constraints.rows.forEach( field => {
    
                if( current_table != field[0]){
                    current_table = field[0]
    
                    // Se não for o inicio, fecha a instrução de criação
                    ddl_pk += !start ? ') ' : '' 
                    
                    createConstraints.push( ddl_pk )
                    ddl_pk = `IF EXISTS (SELECT 1 FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_TYPE='BASE TABLE' AND TABLE_NAME='${current_table}') `
                    ddl_pk += 'ALTER TABLE '+current_table+' ADD CONSTRAINT PK_'+current_table+' PRIMARY KEY (';                
                    
                    start = false;

                    cpIdx_pk = 0;
                    cpIdx_fk = 0;
                }
    
                if(field[0] == field[4]){ // PK
                    //Separa por virgula depois do primeiro campo
                    if(cpIdx_pk != 0){
                        ddl_pk += ','
                    }
                    ddl_pk += field[3]
                    cpIdx_pk++                
                }
            }); 
    
            return createConstraints;
        };

    
        function handleIndexes(indexes){
            // TODO foreach em todos os items aninhados
            let current_table = '';
            let start = true;
            let ddl = '';
            let cpIdx = 0;
            let createIndexes = []
    
            indexes.rows.forEach( field => {
    
                if( current_table != field[0]){
                    current_table = field[0]
    
                    // Se não for o inicio, fecha a instrução de criação
                    ddl += !start ? ') ' : '' 
    
                    //Quebra de linha                    
                    ddl += `
                    `
                    createIndexes.push( ddl )
    
                    ddl = 'CREATE TABLE '+current_table+'('                   
                    start = false;
                    cpIdx = 0;
                }
    
                //Separa por virgula depois do primeiro campo da tabela
                if(cpIdx != 0){
                    ddl += ','
                }
                ddl += field[1]+' '+field[2]+' '+field[3];
                
                if( !!field[4] ) {
                    if(  field[4].substring(0, 7).toUpperCase().trim() == 'SYSDATE' ){
                        ddl += ' default GETDATE()'
                    } else if(  field[4].substring(0, 12).toUpperCase().trim() == 'CURRENT_DATE' ){
                        ddl += ' default GETDATE()'
                    } else if (field[4].substring(0, 32) == `SYS_CONTEXT('nrorg_ctx','nrorg')`){
                        ddl += ` default '${field[5]}'` // Default NRORG
                    } else {
                        ddl += ' default '+field[4]
                    }
                }
                cpIdx++                
            }); 
    
            return createIndexes;
        };

        myPromises.push(req.app.model.StructureModel.getStructure(req.app, filterParams).then( structure => {            
            createStructure = [...handleStructure(structure)];
        }));
        
        myPromises.push(req.app.model.StructureModel.getConstraints(req.app, filterParams).then( constraints => {            
            createContraints = [...handleConstraints(constraints)];
        }));

        // myPromises.push(req.app.model.StructureModel.getConstraintsFromIndexes(req.app, filterParams).then( constraints => {            
        //     createContraintsFromIndexes = [...handleConstraintsFromIndexes(constraints)];
        // }));        

        Promise.all(myPromises).then( _ => {
            res.send([...createStructure, ...createContraints, ...createContraintsFromIndexes]);
        })
    }
}

module.exports = new FosTabController()

const oracledb = require('oracledb');

