const queryUpdater = require('../model/updaterModel');

class UpdaterController {
  /**
   * @returns versão do Updater
   */
  varsao() {
    return '0.0.1';
  }

  /**
   * @param {*} req
   * @param {*} res
   * @returns Retorna as vendas com problema ou o id e vendas true para sem erros.
   */
  async getUnidades(req, res) {
    try {
      const queryResultAll = await queryUpdater.getUpdaterVersao();
      const { rows } = queryResultAll;
      if (!rows.length) {
        return { };
      }
      const updater = [];
      const ids = [];
      const repetidos = {};
      rows.forEach((item) => {
        let itens = {
          id: item[1],
          IDUPDATER: item[0],
          CDFILIAL: item[1],
          NOMEFILIAL: item[2],
          IDUPDATERSISTEMAS: '-',
          DEVOPSID: '-',
          APLICACAO: '-',
          SERVICO: '-',
          UPSISVERATUAL: '-',
          SISTEMASSTATUS: '-',
          VERSAOATUAL: {},
        };

        // this.getVersaoAtual(item[3]).then((versao) => {
        //   itens.VERSAOATUAL = versao;
        //   // console.log('Itenss: ', itens);
        //   return versao;
        // });
        // console.log('Itenss:: ', aff);

        /**
         * Trata o ID para o Item de PARENT_PROJECT
         * ID: 9999, quando repetido vira 9999.x onde x é o número de vezes 9999.1 9999.2 ...
         */
        if (ids.indexOf(item[1]) === -1) {
          ids.push(item[1]);
          updater.push(itens);
          /**
           * versão atual
          */
          // let atual = {};
          // this.getVersaoAtual(item[3]).then((historico) => {
          //   atual = historico;
          // });
          itens = {
            id: item[1],
            IDUPDATER: item[0],
            CDFILIAL: item[1],
            NOMEFILIAL: item[2],
            IDUPDATERSISTEMAS: item[3],
            DEVOPSID: item[5],
            APLICACAO: item[6],
            SERVICO: item[7],
            UPSISVERATUAL: item[8],
            SISTEMASSTATUS: item[9],
            PARENT_PROJECT: item[1],
            UPSISVERDISPONIVEL: '-',
            CDOPERADOR: item[12],
            UPVERDATA: item[13],
            UPVERSTATUS: item[14],
            VERSAOATUAL: {},
          };
          ids.forEach((i) => {
            repetidos[i] = (repetidos[i] || 0) + 1;
            [repetidos].forEach((it) => {
              itens.id = item[1] + '.' + (it[item[1]]);
            });
          });
          updater.push(itens);
        } else {
          ids.push(item[1]);
          itens = {
            id: item[1],
            IDUPDATER: item[0],
            CDFILIAL: item[1],
            NOMEFILIAL: item[2],
            IDUPDATERSISTEMAS: item[3],
            DEVOPSID: item[5],
            APLICACAO: item[6],
            SERVICO: item[7],
            UPSISVERATUAL: item[8],
            SISTEMASSTATUS: item[9],
            PARENT_PROJECT: item[1],
            UPSISVERDISPONIVEL: '-',
            CDOPERADOR: item[12],
            UPVERDATA: item[13],
            UPVERSTATUS: item[14],
            VERSAOATUAL: {},
          };
          ids.forEach((i) => {
            repetidos[i] = (repetidos[i] || 0) + 1;
            [repetidos].forEach((it) => {
              itens.id = item[1] + '.' + (it[item[1]] -1);
            });
          });
          updater.push(itens);
        }
      });

      // if (updater.length > 0) {
      //   updater.forEach((itens) => {
      //     // console.log('Itens::', itens.IDUPDATERSISTEMAS);
      //     // if (Number.isInteger(itens.IDUPDATERSISTEMAS)) {
      //     const versaoSistemas = this.getVersaoAtual(itens.IDUPDATERSISTEMAS).then((versao) => {
      //       itens.VERSAOATUAL = versao;
      //       // console.log(itens);
      //       return itens;
      //     });
      //     // }
      //   });
      // }
      return updater;
    } catch (error) {
      console.log(error);
      return error;
    }
  }

  /**
   *
   * @param {*} idsistemas
   * @returns
   */
  async getVersaoAtual(idsistemas) {
    let historico = {};
    if (Number.isInteger(idsistemas)) {
      const queryResultAll = await queryUpdater.getUpdaterVersaoAtual({
        MAX_ROW: 1,
        IDUPDATERSISTEMAS: idsistemas,
      });
      const { rows } = queryResultAll;
      if (!rows.length) {
        return { };
      }
      historico = {
        NMOPERADOR: rows[0][0],
        CDOPERADOR: rows[0][1],
        IDUPDATER: rows[0][2],
        CDFILIAL: rows[0][3],
        NOMEFILIAL: rows[0][4],
        IDUPDATERSISTEMAS: rows[0][5],
        DEVOPSID: rows[0][7],
        APLICACAO: rows[0][8],
        SERVICO: rows[0][9],
        UPSISVERATUAL: rows[0][10],
        SISTEMASSTATUS: rows[0][11],
        IDUPDATERVERSAO: rows[0][12],
        UPVERDATA: rows[0][15],
        UPVERSTATUS: rows[0][16],
      };
    }
    return historico;
  }

  async updaterSistemas(data) {
    try {
      console.log('Data 113', data);
      const dia = new Date();
      const dataFormatada = ("0" + dia.getDate()).substr(-2) + "-"  + ("0" + (dia.getMonth() + 1)).substr(-2) + "-" + dia.getFullYear();
      console.log('Data é:', dataFormatada);
      const queryResultAll = await queryUpdater.setUpdaterVersao({
        IDUPDATERSISTEMAS: data.dados.IDUPDATERSISTEMAS,
        CDOPERADOR: data.operador,
        UPVERDATA: dataFormatada,
        UPVERSTATUS: 0,
      });
      queryResultAll.connection.commit();
      return queryResultAll;
    } catch (error) {
      return error;
    }
  }

  /**
   *
   * @param {*} req
   * @param {*} res
   * @returns
   */
  async getHistorico(data) {
    try {
      const historico = [];
      const queryResultAll = await queryUpdater.getUpdaterVersaoAll({
        MAX_ROW: 25,
        IDUPDATERSISTEMAS: data.dados.IDUPDATERSISTEMAS,
        CDFILIAL: data.dados.CDFILIAL,
        IDUPDATER: data.dados.IDUPDATER,
      });

      const { rows } = queryResultAll;
      if (!rows.length) {
        return { };
      }
      rows.forEach((item) => {
        historico.push({
          NMOPERADOR: item[0],
          CDOPERADOR: item[1],
          IDUPDATER: item[2],
          CDFILIAL: item[3],
          NOMEFILIAL: item[4],
          IDUPDATERSISTEMAS: item[5],
          DEVOPSID: item[7],
          APLICACAO: item[8],
          SERVICO: item[9],
          UPSISVERATUAL: item[10],
          SISTEMASSTATUS: item[11],
          IDUPDATERVERSAO: item[12],
          UPVERDATA: item[15],
          UPVERSTATUS: item[16],
        });
      });

      return historico;
    } catch (error) {
      console.log(error);
      return error;
    }
  }

  /**
   * @author Daniel Souza <daniel.souza@teknisa.com>
   * @param {*} data
   * @returns obj lista de sistemas a serem atualizados
   */
  async getVersaoDisponivel(data) {
    const queryResultAll = await queryUpdater.getVersaoDisponivel(data);
    const { rows } = queryResultAll;
    const services = [];

    if (!rows[0].length) {
      return {};
    }

    services.push({
      'id': rows[0][0].toLowerCase(),
      'IDUPDATERVERSAO': rows[0][1],
    });

    return services;
  }

  /**
   * @author Daniel Souza <daniel.souza@teknisa.com>
   * @param {*} data
   * @returns obj lista de sistemas a serem atualizados
   */
   async updateVersaoDisponivel(data) {
    const queryResultAll = await queryUpdater.updateVersaoDisponivel(data);
    queryResultAll.connection.commit();
    return queryResultAll;
  }
}

module.exports = new UpdaterController();
